package br.com.rhino.personcompany;

import java.time.LocalDateTime;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.Table;

@Entity
@Table(name = "address")
public class Address {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    public Long id;
    public String street;
    public String district;
    public String city;
    public String state;
    @Column(name = "zip_code")
    public String zipCode;
    @Column(name = "dt_update")
    public LocalDateTime updatedAt;
    @Column(name = "dt_creation")
    public LocalDateTime createdAt;

    @PrePersist
    public void prePersist() {
        final LocalDateTime now = LocalDateTime.now();
        createdAt = now;
    }

    @PreUpdate
    public void preUpdate() {
        updatedAt = LocalDateTime.now();
    }

    public Address id(final Long id) {
        this.id = id;
        return this;
    }

    public Address street(final String street) {
        this.street = street;
        return this;
    }

    public Address district(final String district) {
        this.district = district;
        return this;
    }

    public Address city(final String city) {
        this.city = city;
        return this;
    }

    public Address state(final String state) {
        this.state = state;
        return this;
    }

    public Address zipCode(final String zipCode) {
        this.zipCode = zipCode;
        return this;
    }
}
