package br.com.rhino.personcompany;

import java.time.LocalDateTime;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.OneToOne;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.Table;

import io.quarkus.hibernate.orm.panache.PanacheEntityBase;

@Entity
@Table(name = "person_company")
@Inheritance(strategy = InheritanceType.JOINED)
public class PersonCompany extends PanacheEntityBase {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    public Long id;
    @Column(name = "name_company_name")
    public String nameCompanyName;
    public String email;
    public String phone;
    @Column(name = "dt_creation")
    public LocalDateTime createdAt;
    @Column(name = "dt_update")
    public LocalDateTime updatedAt;
    @OneToOne
    public Address address;

    @PrePersist
    public void prePersist() {
        final LocalDateTime now = LocalDateTime.now();
        createdAt = now;
        updatedAt = now;
    }

    @PreUpdate
    public void preUpdate() {
        updatedAt = LocalDateTime.now();
    }

    public PersonCompany id(final Long id) {
        this.id = id;
        return this;
    }

    public PersonCompany nameCompanyName(final String nameCompanyName) {
        this.nameCompanyName = nameCompanyName;
        return this;
    }

    public PersonCompany email(final String email) {
        this.email = email;
        return this;
    }

    public PersonCompany phone(final String phone) {
        this.phone = phone;
        return this;
    }

    public PersonCompany address(final Address address) {
        this.address = address;
        return this;
    }
}

